/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM
 * /Users/pedemonte/builds/181/mozilla/extensions/webservices/public/nsISOAPEncoding.idl
 */

package org.mozilla.interfaces;

/** 
 * This interface provides access to a collection of SOAP encodings
 *   and schemas. The registry is owned by an encoding.
 */
public interface nsISOAPEncodingRegistry extends nsISupports {

  String NS_ISOAPENCODINGREGISTRY_IID =
    "{9fe91a61-3048-40e3-99ef-e39ab946ae0b}";

  /**
   * Get an associated encoding for a different encoding style.  If
   *   there is no default associated encoding available for the
   *   specified encoding style, then if aCreateIf is specified, one
   *   is created, otherwise a null is returned.  Associated encodings
   *   are the set of encodings that may be used and modified together
   *   as a set.
   *
   * @param aStyleURI The style URI of the associated encoding.
   *
   * @param aCreateIf If true, then create the associated encoding if it
   *   does not already exist, otherwise return the existing encoding.
   *
   * @return The associated encoding which corresponds to the
   *   specified styleURI, or null if the spefied alternative encoding
   *   does not exist and it was not requested that it be created.
   */
  nsISOAPEncoding getAssociatedEncoding(String aStyleURI, boolean aCreateIf);

  /**
    * The schema collection used by the owning encoding and all 
    *   associated encodings.
    */
  nsISchemaCollection getSchemaCollection();

  /**
    * The schema collection used by the owning encoding and all 
    *   associated encodings.
    */
  void setSchemaCollection(nsISchemaCollection aSchemaCollection);

}